import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
//import java.awt.Color;
import javax.swing.JOptionPane;
import java.net.*;
import java.io.*;

/**
 * Dunia Ular!
 * 
 * @author Keenan M. Gebze
 * @version 1.0
 */
public class DuniaUlar  extends World
{

    public Counter nilai;
    private KepalaUlar utama;

    /**
     * Konstruktor untuk DuniaUlar.
     * Membuat latar belakang DuniaUlar.
     * Menambahkan objek objek yang diperlukan.
     */
    public DuniaUlar()
    {    
        /**
         * Membuat DuniaUlar dengan ukuran 20x20, dan setiap kotak 20 pixel * 20 pixel
         */
        super(20, 20, 20);

        /**
         * Mengisi latar belakang dengan warna 0, 100, 0, kira kira hijau tua.
         */
        GreenfootImage latar = new GreenfootImage(20,20);
        latar.setColor(new Color(0, 100, 0));
        latar.fill();
        setBackground(latar);

        /**
         * Membuat dan menambahkan KepalaUlar "utama", Dan menambah makanan masuk kedalam DuniaUlar ini.
         */
        utama = new KepalaUlar();
        addObject(utama, getWidth()/2, getHeight()/2);
        addObject(new MakananUlar(), Greenfoot.getRandomNumber(getWidth()), Greenfoot.getRandomNumber(getWidth()));

        nilai = new Counter();
        addObject(nilai, getWidth()/2, 2);

        setPaintOrder(Counter.class, MakananUlar.class);
    }

    public void act() {
        if((utama !=null) && (utama.getWorld() == null)) {
            gameKalah();
            utama = null;
        }
    }

    public void gameKalah() {
        String nama = "=";
        
        URLConnection poster = null;
        OutputStreamWriter out = null;
        InputStreamReader in = null;
        
        try {
            
            while(nama.contains("=")) {
                nama = JOptionPane.showInputDialog(null, "Enter your name: ", "Uploading Score", 1);
            }
            
            URL site = new URL("http://mandela.1free.ws/greenfootgame/score.php");
            poster = site.openConnection();
            poster.setDoOutput(true);
     
            out = new OutputStreamWriter(poster.getOutputStream());
            out.write("username="+nama+"&"+"userscore="+nilai.getValue());
            out.close();
            
            in = new InputStreamReader(poster.getInputStream());
            in.close();
        }catch(IOException e) {
            
        }catch(NullPointerException e) {
            
        }
        
        addObject(new ScoreList(), getWidth()/2, 4);
        
    }

}
